Subject: Re: Modification of event and sig parameter ASN.1 syntax

From: Richie Wu <[email-masked]>
Date: Mon, 4 Dec 2000 20:27:28 -0800

Hi Troy,

Thank you for your timely response. I think your
solution is convenient for the protocol
implementation. We are confused with the value
codecing issues. As per your idea, I think the only
situation that we need to retain OCTET STRING is we
want to transfer raw data, which is opaque to the
protocol. In this case we can use the codec method
suggested in B.3 and B.4 of the implementor's guide
version 7.

And I suggest that we add comments in the package
definition section in order to uniform how to codec
the data type defined in this section. The data need
to be converted from host byte order to net byte order
in case of integer, double and boolean while encoding,
vice versus for decoding; the char and string type can
be memory copy directly. And the elements of sub-list
or enumeration type is also a type of integer, double
or boolean, hence they can be codeced following the
above rules. Thus, we can eliminate a lot of
interoperability problems.

Best regards,

Richie Wu

--- Troy Cauble <[email-masked]> wrote:
>
>
> Yes, please!  I've brought up the OCTET STRING
> problem
> before, and "double wrapping" the values was
> discussed.
>
> But we didn't talk about the missing Relation
> information
> (>, <, !=, etc.) !
>
> If people like your first proposal, I'd suggest that
> PropertyParm be reused rather than creating new
> constructs
> just like it.  The second version is good too; that
> construct
> maps directly to the ABNF parmValue.
>
> Either of these proposals would help a great deal.
> Since
> we're discussing changing the ASN.1, I'd propose we
> go a
> step further and get rid of the OCTET STRING hole,
> as
> follows.
>
>
>       Value ::= CHOICE        -- or another name, depending
>       {                       -- on which model below is chosen
>
>               boolValue       BOOLEAN,
>               intValue        INTEGER,
>               stringValue     IA5String,
>               -- etc.  for all the property/parameter
>               -- Types in section 12.1.2 and 12.2
>       }
>
> -troy
>
> Richie Wu wrote:
> >
> > Hello everybody,
> >
> > I have some doubts about the definition of Event
> > Descriptor Parameters and Signal Descriptors in
> ASN.1.
> >
> > In ASN.1 we have defined the syntax for event
> > parameters and additional signal parameters which
> were
> > described in package definition as the following
> > format:
> >
> > Value ::= OCTET STRING
> >
> > EventParameter ::= SEQUENCE
> >    {
> >         eventParameterName              Name,
> >         value                           Value
> >    }
> >
> > SigParameter ::= SEQUENCE
> >    {
> >         sigParameterName                Name,
> >         value                           Value
> >    }
> >
> > The issue is that we lose some information in
> Value
> > filed, because it loses the parameter type
> > information. And the appropriate items in ABNF
> which
> > matches the value field of the definition is
> defined
> > like:
> >
> > parmValue            = (EQUAL alternativeValue/
> > INEQUAL VALUE)
> >    alternativeValue     = ( VALUE
> >                           / LSBRKT VALUE *(COMMA
> > VALUE) RSBRKT
> >                             ; sublist (i.e. A AND
> B
> > AND ...)
> >                           / LBRKT VALUE *(COMMA
> VALUE)
> > RBRKT
> >                             ; alternatives (i.e. A
> OR
> > B OR ...)
> >                           / LSBRKT VALUE COLON
> VALUE
> > RSBRKT )
> >                             ; range
> >    INEQUAL              = LWSP (">" / "<" / "#" )
> LWSP
> >
> >    LSBRKT               = LWSP "[" LWSP
> >    RSBRKT               = LWSP "]" LWSP
> >
> > On  the other hand, as per the section ?12.1.2
> > Properties?, we have defined the ASN.1 syntax of
> > property parameters in package which is showed
> below:
> >
> > PropertyParm ::= SEQUENCE
> >    {
> >         name            PkgdName,
> >         value           SEQUENCE OF OCTET STRING,
> >         extraInfo       CHOICE
> >                 {
> >                         relation        Relation,
> >                         range           BOOLEAN,
> >                         sublist         BOOLEAN
> >                 } OPTIONAL,
> >         ...
> > }
> >
> > which have the samilar description in section 12.
> >
> > So, can we modify the appropriate ASN.1 definition
> > like this:
> >
> > SigsEventsParm ::= SEQUENCE
> >    {
> >         name            Name,
> >         value           SEQUENCE OF OCTET STRING,
> >         extraInfo       CHOICE
> >                 {
> >                         relation        Relation,
> >                         range           BOOLEAN,
> >                         sublist         BOOLEAN
> >                 } OPTIONAL,
> >         ...
> > }
> >
> > EventParameter ::= SigsEventsParm
> > SigParameter     ::= SigsEventsParm
> >
> > Or we modify the Value definition while leave the
> > other as it is:
> > Value ::= SEQUENCE
> >    {
> >         value           SEQUENCE OF OCTET STRING,
> >         extraInfo       CHOICE
> >                 {
> >                         relation        Relation,
> >                         range           BOOLEAN,
> >                         sublist         BOOLEAN
> >                 } OPTIONAL,
> >         ...
> > }
> >
> > Best regards,
> >
> > Richie Wu
> >
> > =====
> > Huawei Technologies India Private Limited
> >
> > Unit 10, 2nd Floor, Innovator Block
> > International Tech Park, Whitefield Main Road
> > Bangalore 560 066, India
> > TEL: 0091-80-841 0061/0753/0755
> > FAX: 0091-80-841 0063
> >
> > __________________________________________________
> > Do You Yahoo!?
> > Yahoo! Shopping - Thousands of Stores. Millions of
> Products.
> > http://shopping.yahoo.com/

=====
Huawei Technologies India Private Limited

Unit 10, 2nd Floor, Innovator Block
International Tech Park, Whitefield Main Road
Bangalore 560 066, India
TEL: 0091-80-841 0061/0753/0755
FAX: 0091-80-841 0063

__________________________________________________
Do You Yahoo!?
Yahoo! Shopping - Thousands of Stores. Millions of Products.
http://shopping.yahoo.com/